//********************************************************
//
// Example Application of BRD_xxx functions for GC5016 service.
//
// (C) InSys by Sklyarov A. Dec, 2006
//
//=********************************************************

#include	<conio.h>
#include	<stdio.h>
#include	<fcntl.h>
#include	<sys\stat.h>
#include	<share.h>
#include	<io.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"CtrlGc5016.h"
#include	"CtrlCmpSC.h"
#include	"ctrlsdram.h"

#define		PI2 6.2831853071795864
#define		kSpace	0x3920
#define		MaxNumParamDdc	2000

//---------------------------------------------------------------------------
typedef struct 
{
 U32   WorkMode;
 U32   InputMode;
 U32   SamplesPerChannel;
 U32   IsSystemMemory;
 U32   ReadModeSDRAM;
 U32   isPldLoadAlways;
 TCHAR IniFileName[100];
}EXAM_PARAM;

EXAM_PARAM g_ExamParam=
{
	1,		// WorkMode: 0-one time DMA, 1-one time CPU
	1,		// InputMode: 0-not usinng SDRAM,1- using SDRAM
	1024,	// SamplesPerChannel
	0,		// IsSystemMemory
	0,		// ReadModeSDRAM: 0-auto, 1 - free 
	1,		// isPldLoadAlways: 1 - always
	{"\\exam_gc5016.ini"} //IniFileName
};
//---------------------------------------------------------------------------
typedef struct 
{
    U32  ClockSource;
    U32  ClockValue;
	U32	 AdmMode;
    U32  MaskChannels;
  	U32	 SyncModeDdc;
  	U32	 GainAdc0;
  	U32	 GainAdc1;
  	U32	 StartSource;
	U32	 StartInverse;
	U32  StartTrigger; 
	U32	 StopSource;
	U32	 StopInverse;
	float ThresholdComp1;
	TCHAR PldFileName[100];
	TCHAR PrgFileName[100];
	TCHAR ServiceAdmName[100];
} ADM_PARAM;				// ADMDDC5016 

ADM_PARAM   g_AdmParam =	// Read from ini-file
{
    0,			// ClockSource: 0-internal, 1-external
    160000000,	// ClockValue (Hz) for mode Adc-samples(g_ExamParam.AdmMode=0)
 	1,			// AdmMode: 0-samples from ADC, 1-samples from DDC
    1,			// ChannelsMask: 1,3 for mode Adc-samples(g_ExamParam.AdmMode=0)
  	1,			// SyncModeDdc: 1 -sync from start, 2-program
  	0,			// GainAdc0: 0-gain=1, 1-gain=2
  	0,			// GainAdc1: 0-gain=1, 1-gain=2
  	0,			// StartSource: source of start : 0-programm, 2-SDX(comparator 1)
	0,			// StartInverse: inverse signal start: 0-no, 1-yes    
	0,			// StartTrigger: start mode : 0- potential, 1-trigger
	0,			// StopSource: source of stop by trigger start mode
	0,			// StopInverse: inverse signal stop: 0-no, 1-yes
	0.1f,		// ThresholdComp1 (v)
	{""},		// PldFileName
	{""},		// PrgFileName
	{"GC50160"}	// ServiceAdmName
	

//---------------------------------------------------------------------------
};
typedef struct{
	U32		ClockValue;				
	U32		ModeOfDdc;
	U32		MaskAdc;
	U32		MaskChannels;
	U32		Decimation[4];
	U32		Fc[4];
	U32		AdcChan[4];
	U32		ParamDdcChip[MaxNumParamDdc];
} DDC_PARAM, *PDDC_PARAM;

DDC_PARAM	g_DdcParam={ // For mode DDC-samples. Read from prg-file
	10000000,	//		ClockValue				
	0,			//		ModeOfDdc
	1,			//		MaskAdc
	1,		    //		MaskDdc;
	1,			//		MaskChannels
	8,			//		Decimation[0]
	8,			//		Decimation[1]
	8,			//		Decimation[2]
	8,			//		Decimation[3]
	10700000,	//		Fc[0]
	10700000,	//		Fc[1]
	10700000,	//		Fc[2]
	10700000,	//		Fc[3]
	0,			//		AdcChan[0]
	0,			//		AdcChan[1]
	0,			//		AdcChan[2]
	0,			//		AdcChan[3]
};
PDDC_PARAM pDdcParam = &g_DdcParam;
//---------------------------------------------------------------------------
//=**************************** ReadIniPrepare ******************************
//=***************************************************************************
typedef struct {char section[25]; int format;void *ptr; char title[25]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{"Option", 0, (void*)&g_ExamParam.WorkMode, "WorkMode" },
	{"Option", 0, (void*)&g_ExamParam.InputMode, "InputMode" },
	{"Option", 0, (void*)&g_ExamParam.SamplesPerChannel, "SamplesPerChannel" },
	{"Option", 0, (void*)&g_ExamParam.IsSystemMemory, "IsSystemMemory" },
	{"Option", 0, (void*)&g_ExamParam.ReadModeSDRAM, "ReadModeSDRAM" },
	{"Option", 0, (void*)&g_ExamParam.isPldLoadAlways, "isPldLoadAlways" },
	{"device0_gc50160", 3, (void*)&g_AdmParam.PldFileName, "PldFileName" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.ClockSource,"ClockSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.ClockValue,"ClockValue" },
	{"device0_gc50160", 0, (void*)&g_AdmParam.AdmMode, "AdmMode" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.MaskChannels,"MaskChannels" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.SyncModeDdc,"SyncModeDdc" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.GainAdc0,"GainAdc0" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.GainAdc1,"GainAdc1" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartSource,"StartSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartInverse,"StartInverse" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartTrigger,"StartTrigger" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StopSource,"StopSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StopInverse,"StopInverse" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.ThresholdComp1,"ThresholdComp1" },
	{"device0_gc50160", 3, (void*)&g_AdmParam.PrgFileName, "PrgFileName" },
};
//---------------------------------------------------------------------------

const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD
BRD_Handle g_hSrv;
TCHAR g_str[100];
int SetISVI=1;
U32	g_SizeInputBuf=1024;
U32 g_NumChans=0;
U32 *pInputBuf;
BRDctrl_StreamCBufAlloc buf_dscr;
BRDctrl_StreamCBufState streamState;

U32  g_NumItemsProgramDdc;
S32	 gMaxNumSamples=32768;	
bool ReadIniFile( char *pFileName );
void DisplayError(S32 status, TCHAR* cmd_str);
S32  PutSetParamToSrv(BRD_Handle handle, TCHAR *srvName);
bool PutSetParamToSDRAM(void);
S32  SdramSettings(BRD_Handle handle, U32 *bBuf_size);
S32  FifoInputDMA(void);
S32  FifoInputCPU(void);
int	 ReadPrgFile(TCHAR *filename, U32 *dst, PDDC_PARAM pParam,int maxsize);
void WriteFlagSinc(int flg, int isNewParam);
int  ReadFlagSinc(void);
int  WriteFileISVI_Adc(U32 *src);
int  WriteFileISVI_Ddc(U32 *src);

//=*************************************** main ************************************************
//=*********************************************************************************************
void main( int argc, char *argv[] )
{
	S32		status;
//	TCHAR	Buffer[128];
 	U32 isISVI;
	
	fflush(stdout);
	setbuf(stdout, NULL);

	if(!ReadIniFile(g_ExamParam.IniFileName ))
	{
		printf("Can't open file: %s !\n",g_ExamParam.IniFileName);
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}
	g_NumItemsProgramDdc=ReadPrgFile(g_AdmParam.PrgFileName, g_DdcParam.ParamDdcChip, pDdcParam,MaxNumParamDdc);
	if(g_NumItemsProgramDdc==-1)
	{
		printf("Can't open file: %s !\n",g_AdmParam.PrgFileName);
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}

	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); 
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); 

	// Get list LID 
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); // Get Info about device
		printf("Board %d: %s, DevID=0x%x, RevID=0x%x, Bus=%d, Dev=%d, Slot=%d,pID=%d.\n", 
		iDev,info.name, info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot,info.pid);
	}

	BRD_Handle handle;
	//handle = BRD_open(lidList.pLID[0], BRDopen_EXCLUSIVE, NULL);  //     
	handle = BRD_open(lidList.pLID[0], BRDopen_SHARED, NULL);  //     
	delete lidList.pLID;
	if(handle<= 0)
	{
		printf("Can't open Board 0 !\n");
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}
	printf("Open Board 0\n");
	BRD_PuList PuList[5];
	U32 ItemReal;
	status = BRD_puList(handle, PuList, 5, &ItemReal); // Get List Programming Unit
	if(ItemReal <= 5)
	{
		for(U32 j = 0; j < ItemReal; j++)
		{
			if(PuList[j].puCode == PLD_CFG_TAG)
			{ 
					//   
					U32	PldState;
					status = BRD_puState(handle, PuList[j].puId, &PldState);
					printf("PldState = %d\n", PldState);
					if(PuList[j].puId == 0x100 && (g_ExamParam.isPldLoadAlways || !PldState))
					{	// Load PLD
						printf("Loading PLD... %s\n",g_AdmParam.PldFileName);
						LARGE_INTEGER Frequency, StartPerformCount, StopPerformCount;
						int bHighRes = QueryPerformanceFrequency (&Frequency);
						QueryPerformanceCounter (&StartPerformCount);
						status = BRD_puLoad(handle, PuList[j].puId, g_AdmParam.PldFileName, &PldState);
						QueryPerformanceCounter (&StopPerformCount);
						double msTime = (double)(StopPerformCount.QuadPart - StartPerformCount.QuadPart) / (double)Frequency.QuadPart * 1.E3;
						printf("Loading time is %.2f s\n", msTime / 1000);
						if(BRD_errcmp(status, BRDerr_OK))
						{
							printf("load is OK.\n");
						}
						else
						{
							printf("Error load ! \n");
							printf("Press any key for leaving program...\n");
							_getch();	
							_exit(0);
						}
					}

			}
		}
	}
	BRD_ServList srvList[10];
	status = BRD_serviceList(handle, 0, srvList, 10, &ItemReal);
	if(ItemReal <= 10)
	{
		for(U32 j = 0; j < ItemReal; j++)
		{
			printf("Service %d: %s, Attr = %X.\n",
							j, srvList[j].name, srvList[j].attr);
		}
	}
	U32 mySrv=0;
	U32 g_nSrv=lidList.itemReal;
	for(U32 iSrv = 0; iSrv < ItemReal; iSrv++)
	{
			if(!strcmp(srvList[iSrv].name, g_AdmParam.ServiceAdmName))mySrv=1;
	}
	if(mySrv==0)
	{
		printf("Service: %s not found !\n",g_AdmParam.ServiceAdmName);
		printf("Press any key for leaving program...\n");
		_getch();	
		_exit(0);
	}

   PutSetParamToSrv(handle, g_AdmParam.ServiceAdmName);

	//---------------- Cal SizeInputBuf ------------------------
	if(g_AdmParam.AdmMode==0)//	Samples from ADC
	{
		for(int i=0;i<2;i++)
			if(g_AdmParam.MaskChannels&(1<<i))g_NumChans++;
		g_SizeInputBuf=g_NumChans*g_ExamParam.SamplesPerChannel*2;
		printf("Samples from ADC\n");
	}
	if(g_AdmParam.AdmMode==1)//	Samples from DDC
	{
		for(int i=0;i<4;i++)
			if(g_DdcParam.MaskChannels&(1<<i))g_NumChans++;
		g_SizeInputBuf=g_NumChans*g_ExamParam.SamplesPerChannel*4;
		printf("Samples from DDC\n");
	}
	U32 tetrad;
	ULONG target;
	if(g_ExamParam.InputMode==0) // not using SDRAM
	{
 	   target = 0;		//  data to  FIFO
	   status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETTARGET, &target);
	   printf("SDRAM not use! \n");
	}
	if(g_ExamParam.InputMode==1) // use SDRAM
	{
 	   target = 2;		//  data to memory
	   status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETTARGET, &target);
	   printf("SDRAM  use! \n");
	}
//---------------------------------------------------------------------------
	if(g_ExamParam.InputMode==1)
	{
		if(!PutSetParamToSDRAM())			// use SDRAM
		{
			printf("SDRAM is absent!\n");
			printf("Press any key for leaving program...\n");
			_getch();	
			_exit(0);
	
		}
	}
	printf("SizeInputBuf= %d  bytes\n",g_SizeInputBuf);
	printf("SamplesPerChannel= %d  \n",g_ExamParam.SamplesPerChannel);


//---------------------------------------------------------------------------
	//-****************** Input date with DMA *****************************
	if(g_ExamParam.WorkMode==0)
	{
		printf("\nInput date with DMA\n");
		buf_dscr.dir = BRDstrm_DIR_IN;
		buf_dscr.isCont = g_ExamParam.IsSystemMemory; 
		buf_dscr.blkNum = 1;
		buf_dscr.blkSize = g_SizeInputBuf;
		buf_dscr.ppBlk = new PVOID[buf_dscr.blkNum];
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr.dir);

		if(g_ExamParam.InputMode==0) // no use SDRAM
		{
		   BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_GETSRCSTREAM, &tetrad);
		   BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_SETSRC, &tetrad);
		}
		if(g_ExamParam.InputMode==1) // use SDRAM
		{
		   BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad);
		   BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_SETSRC, &tetrad);
		}
		pInputBuf=(U32*)buf_dscr.ppBlk[0];
		S32 nf=0;
		printf("\n\n");
		while(!GetAsyncKeyState(VK_ESCAPE))
		{
			if(FifoInputDMA())
			{
				nf = -1;
				break; // ,      (   -)
			}
			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(pInputBuf);	// Samples from ADC
			else
				isISVI = WriteFileISVI_Ddc(pInputBuf);	// Samples from DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);
		}
 		if(nf > 0)
			_getch(); //       Esc
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr);
		delete[] buf_dscr.ppBlk;
	}

	//-****************** Input date with CPU *******************
	  if(g_ExamParam.WorkMode>0) 
	  {
		printf("\nInput date with CPU\n");
		pInputBuf = new U32[g_SizeInputBuf];
		S32 nf=0;
		printf("\n\n");
		while(!GetAsyncKeyState(VK_ESCAPE))
		{
			FifoInputCPU( );
			if(g_AdmParam.AdmMode==0)isISVI = WriteFileISVI_Adc(pInputBuf); // Samples from ADC
			else isISVI = WriteFileISVI_Ddc(pInputBuf);						// Samples from DDC
			nf++;
			if(isISVI)printf("\rFile=%d          ",nf);
			else printf("\rFile=%d  No ISVI!",nf);
	    }
		_getch();
		 delete pInputBuf;
	  }

//end:
	status = BRD_release(g_hSrv, 0);
	status = BRD_close(handle); 
	printf("\nBRD_close: OK");
	status = BRD_cleanup();
	printf("\nBRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();

}
//-******************************** End main **************************************
//=*********************************************************************************
void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}

//      ini-:
//    FileName -  ini- ( ,  )
//    SectionName -  
//    ParamName -   ()
//    defValue -   - (    )
//    strValue -  
//    strSize -   
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize)
{
	GetPrivateProfileString(SectionName, ParamName, defValue, strValue, strSize, FileName);
	TCHAR* pChar = _tcschr(strValue, ';');
	if(pChar) *pChar = 0; //    
	int str_size = lstrlen(strValue);
	for(int i = str_size - 1; i > 1; i--)
		if(strValue[i] != ' ' && strValue[i] != '\t')
		{
			strValue[i+1] = 0;
			break;
		}
}

//=************************** ReadIniFile ********************
//=************************************************************
bool    ReadIniFile( TCHAR *pFileName )
{
	TCHAR Buffer[128];
	TCHAR *endptr;
	TCHAR iniFilePath[MAX_PATH];
	FILE    *stream;

	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);

	_tcscat_s(iniFilePath, pFileName);
	stream = fopen(iniFilePath, "rt" );
    if( stream == NULL)return false;
	else     fclose(stream);

    for(int i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
	{
		GetPrivateProfileString(iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer), iniFilePath);
		switch(iniEntry[i].format){
			case 0:	
				{
					int     base = 10;
					char    *s = Buffer;
					while (isspace(*s)) s++;
                    if( (s[0]=='0') && ((s[1]=='x') || (s[1]=='X')) )
                    base = 16;
                    *(int*)iniEntry[i].ptr = strtoul( Buffer, &endptr, base );
				}
				break;
			case 1:	*(float*)iniEntry[i].ptr=(float)atof(Buffer);
				break;
			case 2:	*(double*)iniEntry[i].ptr=atof(Buffer);
				break;
			case 3:	 
				GetInifileString(iniFilePath, iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer));
				lstrcpy((TCHAR*)iniEntry[i].ptr,Buffer);
				break;

		}
	}
	return true;
}

//=**********************************************************************
S32 PutSetParamToSrv(BRD_Handle handle, TCHAR *srvName)
{
	S32	status;
	U32 mode = BRDcapt_EXCLUSIVE;
	g_hSrv = BRD_capture(handle, 0, &mode, srvName, 10000);
	if(g_hSrv <=0)
	{
		printf("Can't capture service:  %s ",g_AdmParam.ServiceAdmName);
		printf("Press any key for leaving program...\n");
		_getch();	
		_exit(0);
	}	
	if(mode == BRDcapt_EXCLUSIVE) printf("\n%s  Capture mode: EXCLUSIVE\n",srvName);
	if(mode == BRDcapt_SPY)	printf("%s Capture mode: SPY\n",srvName);
	ULONG master=BRDims_SINGLE;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETMASTER, &master);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETMASTER");

   //---------------- SetClkMode ------------------------
	BRD_ClkMode clk_mode;
	clk_mode.src = g_AdmParam.ClockSource;
	clk_mode.value = g_AdmParam.ClockValue;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETCLKMODE, &clk_mode);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETCLKMODE");

	g_AdmParam.ClockSource = clk_mode.src;
	g_AdmParam.ClockValue = (U32)clk_mode.value;

	if(g_AdmParam.ClockSource==0)printf("ClockSource= INTERNAL\n");
	else  printf("ClockSource= EXTERNAL\n");
	printf("ClockValue= %d Hz\n",g_AdmParam.ClockValue);

	//----------------- SetAdm ----------------------------
	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETADMMODE, &g_AdmParam.AdmMode);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETADMMODE");	

	ULONG ddcmode = 0;
	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETDDCMODE, &ddcmode);

	//------------------ Enable ADC ------------------------
	U32  enbadc;
	if(g_AdmParam.AdmMode==0)	// Samples form ADC
	{
		enbadc=g_AdmParam.MaskChannels |1;
	}
	if(g_AdmParam.AdmMode==1)	// Samples form DDC
	{
		enbadc=g_DdcParam.MaskAdc;
	}
	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_ADCENABLE, &enbadc);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_ADCENABLE");

//------------------ Set Channels------------------------
	U32  mchans;
	if(g_AdmParam.AdmMode==0)	// Samples form ADC
	{
		mchans=g_AdmParam.MaskChannels;
	}
	if(g_AdmParam.AdmMode==1)	// Samples form DDC
	{
		mchans=g_DdcParam.MaskChannels;
	}

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETCHANMASK, &mchans);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETCHANMASK");	

   //-------- SetAdcGain ------------------------
	BRD_GC5016AdcSetGain set_gain;
	set_gain.gainAdc = g_AdmParam.GainAdc0;
	set_gain.maskAdc = 1;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETADCGAIN, &set_gain);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETADCGAIN");

	set_gain.gainAdc = g_AdmParam.GainAdc1;
	set_gain.maskAdc = 2;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETADCGAIN, &set_gain);
	if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETADCGAIN");
 
	//----------------------- Set StartMode ------------------------
	BRD_StartMode  startMode;
		
	startMode.startSrc= g_AdmParam.StartSource;
	startMode.startInv= g_AdmParam.StartInverse;
	startMode.trigOn= g_AdmParam.StartTrigger;
	startMode.trigStopSrc= g_AdmParam.StopSource;
	startMode.stopInv= g_AdmParam.StopInverse;
	startMode.reStartMode=0;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETSTARTMODE, &startMode);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETSTARTMODE");

	BRD_CmpSC cmp_sc;
	cmp_sc.src = BRDcmps_CHAN0CLK;
	cmp_sc.thr[0] = g_AdmParam.ThresholdComp1;
	cmp_sc.thr[1] = g_AdmParam.ThresholdComp1;

	status = BRD_ctrl(g_hSrv, 0, BRDctrl_CMPSC_SET, &cmp_sc);
	if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_CMPSC_SET");

	//-----------------------Program DDC ----------------------
	if(g_AdmParam.AdmMode==1)		// Samples from DDC
	{
		printf("PrgFileName= %s\n",g_AdmParam.PrgFileName);
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETDDCMODE, &g_DdcParam.ModeOfDdc);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETDDCMODE");

		BRD_GC5016SetSync ddcSetSync;

		ddcSetSync.syncMode=g_AdmParam.SyncModeDdc;
		ddcSetSync.progSync=0;
		ddcSetSync.slave=0;
		ddcSetSync.resDiv=0;

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETDDCSYNC, &ddcSetSync);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCSYNC");

		BRD_GC5016Program ddcProgram;
		ddcProgram.nItems=g_NumItemsProgramDdc;
		ddcProgram.pData=g_DdcParam.ParamDdcChip;

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_PROGRAMDDC, &ddcProgram);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_PROGRAMDDC");

		status=BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STARTDDC, NULL); //  DDC
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_STARTDDC");

		ddcSetSync.syncMode=g_AdmParam.SyncModeDdc;
		ddcSetSync.progSync=1;
		ddcSetSync.slave=0;
		ddcSetSync.resDiv=0;

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_SETDDCSYNC, &ddcSetSync);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCSYNC");

	}

	return status;
}
//*****************************************************************************
bool PutSetParamToSDRAM(void)
{
	
		S32	status;
		BRD_SdramCfg SdramConfig;
		ULONG PhysMemSize;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_GETCFG, &SdramConfig);
		if(status < 0)
		{
			PhysMemSize = 0; // SDRAM is absent
			return false;
		}
		else
		{					// SDRAM is available
			PhysMemSize =	(1 << SdramConfig.RowAddrBits) *
							(1 << SdramConfig.ColAddrBits) * 
							SdramConfig.ModuleBanks * 
							SdramConfig.ChipBanks *
							SdramConfig.ModuleCnt * 2; // size (U32)

			ULONG mode = g_ExamParam.ReadModeSDRAM;    // 0 - AUTO, 1 - RANDOM
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_SETREADMODE, &mode);
			TCHAR readMode[10];
			if(g_ExamParam.ReadModeSDRAM==0)	// auto
			{
				strcpy(readMode,"AUTO");
			}
			if(g_ExamParam.ReadModeSDRAM==1)	// random
			{
				strcpy(readMode,"RANDOM");
			}
			printf("ReadModeSDRAM = %s \n",readMode);
			printf("SDRAM total size = %d MBytes\n", (PhysMemSize / (1024 * 1024)) * 4);
 

			ULONG addr = 0;
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_SETSTARTADDR, &addr); // set address for write
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_SETREADADDR, &addr);  // set address for read

			ULONG mem_size = g_SizeInputBuf >> 2; // set size activ zone (U32)
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_SETMEMSIZE, &mem_size);
			g_SizeInputBuf = mem_size << 2;		 // get size activ zone (bytes)

			g_ExamParam.SamplesPerChannel=g_SizeInputBuf/g_NumChans/4;
			if(g_AdmParam.AdmMode==0)g_SizeInputBuf *=2;

			if(BRD_errcmp(status, BRDerr_OK))
			{
				return true;
			}
			else
			{
				DisplayError(status, "BRDctrl_SDRAM_SETMEMSIZE");
				return false;
			}
		}

}

//**************************** FifoInputDMA **************************************
//********************************************************************************
S32 FifoInputDMA(void)
{
	S32		status,Status;
	U32 Enable = 1;

	LARGE_INTEGER Frequency, StartPerformCount, StopPerformCount;
	int bHighRes = QueryPerformanceFrequency (&Frequency);

	// set flag request DMA
	ULONG flag = BRDstrm_DRQ_HALF; 
	status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_SETDRQ, &flag);

	if(g_ExamParam.InputMode==0)	// no use SDRAM
	{
		//status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);	  // stop GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFORESET, NULL); // reset FIFO 
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFOSTATUS, &Status);
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_RESETFIFO, NULL);

		BRDctrl_StreamCBufStart start_pars;
		start_pars.isCycle = 0; // no cycle 

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_START, &start_pars); // start DMA

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_START, NULL);			  // start GC5016 

		QueryPerformanceCounter (&StartPerformCount);

		int fl_break = 0;
	    ULONG msTimeout = 5000; // wait end input (20 s)
	    status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);

		QueryPerformanceCounter (&StopPerformCount);

	    if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	
			printf("TIME-OUT! \n");
			fl_break = 1;
		}
	    status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL); // stop GC5016 
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFOSTATUS, &Status);

		if(!fl_break)
		{
			double mcsTime = (double)(StopPerformCount.QuadPart - StartPerformCount.QuadPart) / (double)Frequency.QuadPart * 1.E6;
			printf("Bus transfer rate is %.2f Mbytes/s", g_SizeInputBuf / mcsTime);
		}

		return fl_break;
	}
	//-----------------------------------------------------------------------------------------
	if(g_ExamParam.InputMode==1)	// use SDRAM
	{
		//status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);	  // stop GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFORESET, NULL); // reset FIFO GC5015
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_FIFORESET, NULL);  // reset  FIFO SDRAM
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable);  // enable write to SDRAM
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_START, NULL);	  // start GC5016

		// wait end input
		do {
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
		} while(!Status);

		Enable = 0;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL); // stop  GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable); // disable write SDRAM

		Enable=1;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_READENABLE, &Enable); // enable read SDRAM

		BRDctrl_StreamCBufStart start_pars;
		start_pars.isCycle = 0; // no cycle 

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_START, &start_pars); // start DMA
		int fl_break = 0;

		ULONG msTimeout = 20000; // wait end input buffer.
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
		{	
			printf("TIME-OUT! \n");
			fl_break = 1;
		}
		return fl_break;
	}
	return 0;
}
//=*****************************************************************************
//************************ FifoInputCPU  ***************************************
//******************************************************************************
S32 FifoInputCPU(void)
{
	
	S32	status,Status;
	U32	Enable=1;
	BRD_DataBuf data_buf;
	data_buf.pData = pInputBuf;
	data_buf.size = g_SizeInputBuf;

	if(g_ExamParam.InputMode==0)	// no use SDRAM
	{
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);		  // stop GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFORESET, NULL);	  // reset FIFO 
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFOSTATUS, &Status);
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_START, NULL);		  // start GC5016 
		//   FIFO
		do {
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFOSTATUS, &Status);
		} while(Status & 0x40);
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);		  // stop GC5016 
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_GETDATA, &data_buf);  // get databuf

		return 1;
	}
	if(g_ExamParam.InputMode==1)	// use SDRAM
	{
		// set flag request DMA
		ULONG flag = BRDstrm_DRQ_HALF;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_STREAM_SETDRQ, &flag);

		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);		// stop GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_FIFORESET, NULL);	// reset  FIFO GC5015
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_FIFORESET, NULL);	// reset FIFO SDRAM
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable);	// enable write to SDRAM
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_START, NULL);		// start GC5016

		// wait end input
		do {
			status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
		} while(!Status);

		Enable = 0;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_GC5016_STOP, NULL);		// stop GC5016
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_ENABLE, &Enable);	// disable write to SDRAM

		Enable=1;
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_READENABLE, &Enable); // ReadEnable SDRAM
		status = BRD_ctrl(g_hSrv, 0, BRDctrl_SDRAM_GETDATA, &data_buf);
		return 1;

	}
	return 0;
}

 //=********************** ReadPrgFile *****************************************
//=*****************************************************************************
int  ReadPrgFile( TCHAR *filename, U32* dst, PDDC_PARAM pParam ,int maxsize)
{
    FILE    *stream;
	unsigned		page, adr, data;
	int		ind=0,type;
    char    *endptr;

	stream = fopen( filename, "rt" );
    if( stream == NULL)return -1;

	fgets( g_str, 80, stream );
    fgets( g_str, 80, stream );
    type= atoi(g_str+14);
    fgets( g_str, 80, stream );
	pParam->ClockValue = atoi(g_str+7);
    fgets( g_str, 80, stream );
	pParam->ModeOfDdc = atoi(g_str+11);
	fgets( g_str, 80, stream );
	pParam->MaskAdc = strtoul( g_str+9, &endptr, 0 );
	fgets( g_str, 80, stream );
//	pParam->MaskDdc = strtoul( g_str+9, &endptr, 0 );
	fgets( g_str, 80, stream );
	pParam->MaskChannels = strtoul( g_str+6, &endptr, 0 );
	fgets( g_str, 80, stream );
	pParam->Decimation[0] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[1] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[2] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[3] = atoi(g_str+16);

	fgets( g_str, 80, stream );
	pParam->Fc[0] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[1] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[2] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[3] = atoi(g_str+10);

    fgets( g_str, 80, stream );
	pParam->AdcChan[0] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[1] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[2] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[3] = atoi(g_str+9);

    fgets( g_str, 80, stream );
    while( 1 )
    {
        fgets( g_str, 80, stream );
       	page = strtoul( g_str, &endptr, 0 );
       	adr  = strtoul( endptr, &endptr, 0 );
       	data = strtoul( endptr, &endptr, 0 );
       	dst[ind] = ((page&0xff)<<24) | ((adr&0xff)<<16) | (data&0xffff);
		if( (ind>0) & (dst[ind] == dst[ind-1]) )
			break;	// End of File
        ind++;
		if( ind>=maxsize )
			break;

     }
	return	ind;
}

//************************   For ISVI  ***************************************
//****************************************************************************
//------------------------------------------------------------------------------
//=******************* Write file samples from DDC ****************************
//=*****************************************************************************
//------------------------------------------------------------------------------
int  WriteFileISVI_Ddc(U32 *src)
{
    int fl,rr,i,nWords,nChans=0;
    float    shift[16],gain[16],sample_rate;
    int chan[16];
    int NumOpenChansISVI=0;
    FILE *stream;
    int j=0;
	for(i=0;i<16;i++){shift[i]=0; chan[i]=0;  gain[i]=1.0;}

	if(g_DdcParam.ModeOfDdc==0)			// full rate
		for(int i=0;i<8;i++)
			shift[i]=(float)g_DdcParam.Fc[i%4];
	if(g_DdcParam.ModeOfDdc>0)			// splitIQ, Double rate
       for(int i=0;i<8;i++)
		   shift[i]=(float)g_DdcParam.Fc[i%2];
	for( i=0; i<4; i++ )
	{
		if( g_DdcParam.MaskChannels & (1<<(3-i)) )
		{
            chan[2*nChans] = (3-i)*2;
            chan[2*nChans+1] = (3-i)*2+1;
			nChans++;
		}
	}
	sample_rate=(float)g_DdcParam.ClockValue/g_DdcParam.Decimation[0];
    nWords=g_SizeInputBuf;
	nChans *=2;
    fl=open("data.bin", O_RDWR|O_BINARY |O_CREAT |O_TRUNC ,S_IWRITE|S_IREAD);
    write(fl,src,nWords);
    close(fl);
    stream=fopen("data.bin","a+t");
    fprintf(stream, "\nDEVICE_NAME_________ ADMDDC5016_DDC");
    fprintf(stream, "\nNUMBER_OF_CHANNELS__ %ld",nChans);
    fprintf(stream, "\nNUMBERS_OF_CHANNELS_ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%ld,",chan[i]);
    fprintf(stream, "\nNUMBER_OF_SAMPLES___ %d",g_ExamParam.SamplesPerChannel);
    fprintf(stream, "\nSAMPLING_RATE_______ %f",sample_rate);
    fprintf(stream, "\nBYTES_PER_SAMPLES___ 2" );
    fprintf(stream,"\nSAMPLES_PER_BYTES___ 1");
    fprintf(stream,"\nIS_COMPLEX_SIGNAL?__ ");
    fprintf(stream,"YES");
    fprintf(stream,"\nSHIFT_FREQUENCY_____ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%.1f,",shift[i]);

    fprintf(stream,"\nGAINS_______________ ");
                                for(i=0;i<nChans/2;i++)fprintf(stream,"%.1f,%.1f,",gain[i],gain[i]);
    fprintf(stream, "\nVOLTAGE_OFFSETS_____ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"0.0,");
    fprintf(stream,"\nVOLTAGE_RANGE_______ 1.0" );
    fprintf(stream,"\nBIT_RANGE___________ %d",16 );
    fprintf(stream,"\n" );

    fclose(stream);

    if(SetISVI==1)
	{
        WriteFlagSinc(0xffffffff,0xffffffff);
    }else
	{
        WriteFlagSinc(0xffffffff,0x0);
    }

     for(i=0;i<0x10000;i++)
     {
		rr=ReadFlagSinc();
		if( rr==0 )
		{   SetISVI=0;
			return 1;
		}
	 }

    return 0;

}
//=******************* Write file samples from ADC *****************************
//=*****************************************************************************
//------------------------------------------------------------------------------
int  WriteFileISVI_Adc(U32 *src)
{
    int fl,rr,i,nWords,nChans=0;
    float    shift[16],gain[16],sample_rate;
    int chan[16];
    int NumOpenChansISVI=0;
    FILE *stream;
    int j=0;
	for(i=0;i<16;i++){shift[i]=0; chan[i]=0;  gain[i]=1.0;}

	for( i=0; i<2; i++ )
	{
		if( g_AdmParam.MaskChannels & (1<<i) )
		{
            chan[nChans] = i;
			nChans++;
		}

	}
	sample_rate=(float)g_AdmParam.ClockValue;
    nWords=g_SizeInputBuf;
    fl=open("data.bin", O_RDWR|O_BINARY |O_CREAT |O_TRUNC ,S_IWRITE|S_IREAD);
    write(fl,src,nWords);
    close(fl);
    stream=fopen("data.bin","a+t");
    fprintf(stream, "\nDEVICE_NAME_________ ADMDDC5016_ADC");
    fprintf(stream, "\nNUMBER_OF_CHANNELS__ %ld",nChans);
    fprintf(stream, "\nNUMBERS_OF_CHANNELS_ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%ld,",chan[i]);
    fprintf(stream, "\nNUMBER_OF_SAMPLES___ %d",g_ExamParam.SamplesPerChannel);
    fprintf(stream, "\nSAMPLING_RATE_______ %f",sample_rate);
    fprintf(stream, "\nBYTES_PER_SAMPLES___ 2" );
    fprintf(stream,"\nSAMPLES_PER_BYTES___ 1");
    fprintf(stream,"\nIS_COMPLEX_SIGNAL?__ ");
    fprintf(stream,"NO");
    fprintf(stream,"\nSHIFT_FREQUENCY_____ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%.1f,",shift[i]);

    fprintf(stream,"\nGAINS_______________ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"%.1f,",gain[i]);
    fprintf(stream, "\nVOLTAGE_OFFSETS_____ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"0.0,");
    fprintf(stream,"\nVOLTAGE_RANGE_______ 1.0" );
    fprintf(stream,"\nBIT_RANGE___________ %d",12 );
    fprintf(stream,"\n" );

    fclose(stream);
    if(SetISVI==1)
	{
        WriteFlagSinc(0xffffffff,0xffffffff);
        SetISVI=0;
    }else
	{
        WriteFlagSinc(0xffffffff,0x0);
    }
     for(i=0;i<0x10000;i++)
     {
		rr=ReadFlagSinc();
		if( rr==0 )
		{	
	        SetISVI=0;
			return 1;
		}
	 }
        return 0;

}


//=**********************   WriteFlagSinc ************************************
//*****************************************************************************
void WriteFlagSinc(int flg, int isNewParam)
{
    int fs;
    int val[2];

//    fs = _open( "data.flg", O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
    errno_t err = _sopen_s( &fs, "data.flg", _O_WRONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IWRITE );
    val[0]=flg;
    val[1]=isNewParam;
    _write(fs,val,8);
    _close(fs);
}
//=**********************   ReadFlagSinc **************************************
//*****************************************************************************
int ReadFlagSinc(void)
{
    int fs,flg;
//	fs = _open( "data.flg", O_RDWR|O_BINARY|O_CREAT, S_IREAD|S_IWRITE );
    errno_t err = _sopen_s( &fs, "data.flg", _O_RDONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IREAD );
   _read(fs,&flg,4);
	_close(fs);
    return flg;
}

//=****************************************************************************

// End of file
//
